## libvigraimpex 1.11.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

##################################################
#
#     basic initializations
#
##################################################

PROJECT(vigra)

# read the current version from config_version.hxx
file(READ ${vigra_SOURCE_DIR}/include/vigra/config_version.hxx VIGRA_VERSION_FILE)
string(REGEX MATCH "VIGRA_VERSION_MAJOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MAJOR[ \t\n]" "" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_MAJOR})
string(REGEX MATCH "VIGRA_VERSION_MINOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MINOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MINOR[ \t\n]" "" VIGRA_VERSION_MINOR ${VIGRA_VERSION_MINOR})
string(REGEX MATCH "VIGRA_VERSION_PATCH[ \t\n]+[^ \t\n]+" VIGRA_VERSION_PATCH ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_PATCH[ \t\n]" "" VIGRA_VERSION_PATCH ${VIGRA_VERSION_PATCH})

SET(vigra_version_short ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR})
SET(vigra_version ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR}.${VIGRA_VERSION_PATCH})
message(STATUS "Configuring VIGRA version ${vigra_version}")

SET(CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}  ${vigra_SOURCE_DIR}/config)

include(VigraSetDefaults)
include(VigraCMakeUtils)
INCLUDE_DIRECTORIES(${vigra_SOURCE_DIR}/include)

if(SUPPRESS_3RD_PARTY_WARNINGS)
    set(SUPPRESS_WARNINGS SYSTEM)
endif()

IF(VIGRA_STATIC_LIB)
    SET(LIBTYPE STATIC)
    ADD_DEFINITIONS(-DVIGRA_STATIC_LIB)
ELSE(VIGRA_STATIC_LIB)
    SET(LIBTYPE SHARED)
ENDIF(VIGRA_STATIC_LIB)

IF (MSVC)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_DEPRECATE)
ENDIF ()

IF(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Clang)")
    set(SUFFICIENT_TEMPLATE_DEPTH FALSE)
    TRY_COMPILE(SUFFICIENT_TEMPLATE_DEPTH
                ${CMAKE_BINARY_DIR} ${PROJECT_SOURCE_DIR}/config/checkTemplateDepth.cxx
                COMPILE_DEFINITIONS "-DDEPTH=900")

    IF(SUFFICIENT_TEMPLATE_DEPTH)
        MESSAGE(STATUS "Checking template recursion depth: ok")
    ELSE()
        if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
            # As of cmake 2.8.10, there is a variable CMAKE_CXX_COMPILER_VERSION.
            # Emulate it by a compiler call if not present.
            IF(NOT CMAKE_CXX_COMPILER_VERSION)
                exec_program(${CMAKE_CXX_COMPILER}
                    ARGS ${CMAKE_CXX_COMPILER_ARG1} -dumpversion
                    OUTPUT_VARIABLE CMAKE_CXX_COMPILER_VERSION)
                string(REGEX REPLACE "([0-9])\\.([0-9])(\\.[0-9])?" "\\1.\\2"
                      CMAKE_CXX_COMPILER_VERSION ${CMAKE_CXX_COMPILER_VERSION})
            endif()

            message ("Detected GCC version ${CMAKE_CXX_COMPILER_VERSION}")
            if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.4.0")
                MESSAGE(WARNING "GNU c++ < 4.4 cannot build VIGRANumPy; disabling (found GCC ${CMAKE_CXX_COMPILER_VERSION})")
                SET(WITH_VIGRANUMPY 0)
            elseif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.5.0")
                # gcc 4.4.x syntax is -ftemplate-depth-900 (not =900)
                SET(CMAKE_CXX_FLAGS "-ftemplate-depth-900 ${CMAKE_CXX_FLAGS}")
                MESSAGE(STATUS "Checking template recursion depth: using -ftemplate-depth-900")
            else()
                # new syntax is =900, not -900
                SET(CMAKE_CXX_FLAGS "-ftemplate-depth=900 ${CMAKE_CXX_FLAGS}")
                MESSAGE(STATUS "Checking template recursion depth: using -ftemplate-depth=900")
            endif()
        else()
            # clang uses newer gcc syntax
            SET(CMAKE_CXX_FLAGS "-ftemplate-depth=900 ${CMAKE_CXX_FLAGS}")
            MESSAGE(STATUS "Checking template recursion depth: using -ftemplate-depth=900")
        endif()
    ENDIF()
ENDIF()

if(MSVC)
    string(REGEX MATCH "[0-9.]+" MSVC_VERSION ${CMAKE_GENERATOR})
endif()

if(MACOSX)
    set(CMAKE_MACOSX_RPATH 1)
endif()

option(BUILD_DOCS "Build documentation" ON)
option(BUILD_TESTS "Build test programs" ON)

##################################################
#
#     search for dependencies
#
##################################################

INCLUDE(VigraFindPackage)
VIGRA_FIND_PACKAGE(ZLIB)
VIGRA_FIND_PACKAGE(TIFF NAMES libtiff_i libtiff) # prefer DLL on Windows
VIGRA_FIND_PACKAGE(JPEG NAMES libjpeg)
VIGRA_FIND_PACKAGE(PNG)
VIGRA_FIND_PACKAGE(FFTW3 NAMES libfftw3-3 libfftw-3.3)
VIGRA_FIND_PACKAGE(FFTW3F NAMES libfftw3f-3 libfftwf-3.3)


IF(WITH_OPENEXR)
    FIND_PACKAGE(Imath CONFIG)
    IF(TARGET Imath::Imath)
        FIND_PACKAGE(OpenEXR CONFIG)
        SET(OPENEXR_LIBRARIES
		    OpenEXR::OpenEXR
		    OpenEXR::Iex
			OpenEXR::IlmThread
			Imath::Imath
		)
		get_target_property(OPENEXR_INCLUDE_DIR OpenEXR::OpenEXRConfig INTERFACE_INCLUDE_DIRECTORIES)
		get_target_property(IMATH_INCLUDE_DIR Imath::ImathConfig INTERFACE_INCLUDE_DIRECTORIES)
		include_directories(${OPENEXR_INCLUDE_DIR} ${IMATH_INCLUDE_DIR})
		set(OPENEXR_FOUND TRUE)
	ELSE()
    VIGRA_FIND_PACKAGE(OpenEXR)
	ENDIF()
ENDIF()

IF(WITH_HDF5)
    VIGRA_FIND_PACKAGE(HDF5)
ENDIF()

IF(WITH_LEMON)
    VIGRA_FIND_PACKAGE(LEMON)
ENDIF()

SET(DOXYGEN_SKIP_DOT TRUE)

IF(BUILD_DOCS)
    FIND_PACKAGE(Doxygen)
    FIND_PACKAGE(Python COMPONENTS Interpreter)
ENDIF()

##################################################
#
#     configure boost dependency
#
##################################################

set(WITH_BOOST "OFF")
set(BOOST_MINIMUM_VERSION "1.40.0")
set(WITH_BOOST_COMPONENTS "")

IF(WITH_BOOST_GRAPH)
    set(WITH_BOOST "ON")
ENDIF()

IF(WITH_VIGRANUMPY)
    set(WITH_BOOST "ON")
ENDIF()

IF(WITH_BOOST_THREAD)
    set(WITH_BOOST "ON")
    set(WITH_BOOST_COMPONENTS ${WITH_BOOST_COMPONENTS} thread system date_time chrono)
    set(BOOST_MINIMUM_VERSION "1.55.0")
ENDIF()

IF(WITH_BOOST)
    VIGRA_FIND_PACKAGE(Boost ${BOOST_MINIMUM_VERSION} COMPONENTS ${WITH_BOOST_COMPONENTS})
    # FIXME: the following may be unstable between cmake versions
    SET(Boost_LIB_SUFFIX "${_boost_COMPILER}${_boost_MULTITHREADED}-${Boost_LIB_VERSION}")
ENDIF()

if(WITH_BOOST AND Boost_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${Boost_INCLUDE_DIR})
    IF(WITH_BOOST_THREAD)
        ADD_DEFINITIONS(-DUSE_BOOST_THREAD)
    ENDIF()
endif()

# Must be included AFTER boost is found.
include(VigraDetectThreading)
include(VigraConfigureThreading)

IF(WITH_VIGRANUMPY)
    FIND_PACKAGE(Python COMPONENTS Interpreter Development NumPy)
    FIND_PACKAGE(VIGRANUMPY_DEPENDENCIES)
ENDIF()

if(WITH_BOOST AND Boost_FOUND)
    # configure boost's autolink magic to use the right library name
    # (default on Windows is a mangled name like 'boost_system-vc110-mt-1_51.lib')
    if((Boost_SYSTEM_LIBRARY MATCHES "boost_system\\.lib") OR
       (Boost_PYTHON_LIBRARY MATCHES "boost_python\\.lib") OR
       (Boost_PYTHON_LIBRARY MATCHES "boost_python${Python_VERSION_MAJOR}\\.lib"))
        set(Boost_MANGLED_NAMES 0)
        ADD_DEFINITIONS(-DBOOST_AUTO_LINK_NOMANGLE)
    else()
        set(Boost_MANGLED_NAMES 1)
    endif()
    if((Boost_SYSTEM_LIBRARY AND
        NOT Boost_SYSTEM_LIBRARY MATCHES "libboost_system") OR
       (Boost_PYTHON_LIBRARY AND
        NOT Boost_PYTHON_LIBRARY MATCHES "libboost_python"))
        ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
    endif()
endif()

IF(WITH_VALGRIND)
    FIND_PROGRAM(VALGRIND_EXECUTABLE valgrind)
ENDIF()

########################################
#  finalize compiler flags
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}"
    CACHE STRING  "Flags used by the C compiler during all build types" FORCE)
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}"
    CACHE STRING  "Flags used by the C++ compiler during all build types" FORCE)

##################################################
#
#     setup testing environment
#
##################################################

ADD_CUSTOM_TARGET(check)
ADD_CUSTOM_TARGET(ctest COMMAND ${CMAKE_CTEST_COMMAND})

ADD_CUSTOM_TARGET(check_cpp)
ADD_DEPENDENCIES(check check_cpp)


OPTION(CREATE_CTEST_TARGETS "Create special targets for CTest" OFF)
IF(CREATE_CTEST_TARGETS)
  INCLUDE(CTest)
ENDIF()

IF(WITH_VIGRANUMPY)
    ADD_CUSTOM_TARGET(check_python)
    ADD_DEPENDENCIES(check check_python)
ENDIF()

ENABLE_TESTING()

##################################################
#
#     setup documentation generator
#
##################################################

ADD_CUSTOM_TARGET(doc)

# Automatically push the latest documentation to github's gh-pages.
# This only works when ${DOCDIR} refers to a VIGRA repository that is
# checked out in branch 'gh-pages', and the present repository is
# in branch 'master' (these conditions are checked in the script).
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

    configure_file(${PROJECT_SOURCE_DIR}/config/update-gh-pages.sh.in
                   ${PROJECT_BINARY_DIR}/update-gh-pages.sh @ONLY)
    EXECUTE_PROCESS(COMMAND chmod u+x ${PROJECT_BINARY_DIR}/update-gh-pages.sh OUTPUT_QUIET ERROR_QUIET)

    ADD_CUSTOM_TARGET(gh-pages
          ${PROJECT_BINARY_DIR}/update-gh-pages.sh
          DEPENDS doc
          WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
          COMMENT "Pushing documentation to github pages.")
endif()

##################################################
#
#     setup private experimentation target
#
##################################################

ADD_CUSTOM_TARGET(experiments)

##################################################
#
#     subdirectories
#
##################################################

ADD_SUBDIRECTORY(src)

IF(BUILD_TESTS)
    ADD_SUBDIRECTORY(test)
ENDIF()

IF(BUILD_DOCS)
    ADD_SUBDIRECTORY(docsrc)
ENDIF()

IF(WITH_VIGRANUMPY)
    ADD_SUBDIRECTORY(vigranumpy)
ENDIF()

IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/private/CMakeLists.txt)
    ADD_SUBDIRECTORY(private EXCLUDE_FROM_ALL)
ENDIF()


set(LIB_SUFFIX "" CACHE STRING "Define suffix of lib directory name (32/64)" )

##################################################
#
#     global installation commands
#
##################################################

INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/include/vigra
        DESTINATION include)

##################################################
#
#     enable CPack package generation
#
##################################################
INCLUDE(CPackConfig)

##################################################
#
#     add target vigra-$version-src.tar.gz
#
##################################################

find_program(GIT_EXECUTABLE
              NAMES git git.exe git.cmd
              HINTS $ENV{ProgramFiles}/Git/bin
              DOC "git command line client")

CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/package-src.cmake.in
                ${PROJECT_BINARY_DIR}/package-src.cmake
                @ONLY IMMEDIATE)

add_custom_target(PACKAGE_SRC_TAR
                   COMMAND ${CMAKE_COMMAND} -P package-src.cmake
                   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
                   COMMENT "Creating ${PROJECT_BINARY_DIR}/vigra-${vigra_version}-src.tar.gz")

ADD_DEPENDENCIES(PACKAGE_SRC_TAR check)
ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_cpp)
IF(WITH_VIGRANUMPY AND PYTHON_SPHINX)
    ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_python)
ENDIF()

##################################################
#
#  enable other non-CMake projects to find Vigra
#
##################################################

IF(NOT WIN32)
# vigra-config script for (non-CMake-based) third party packages
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/vigra-config.in
        ${PROJECT_BINARY_DIR}/bin/vigra-config
        @ONLY IMMEDIATE)
INSTALL(FILES ${PROJECT_BINARY_DIR}/bin/vigra-config
        DESTINATION bin
        PERMISSIONS
            OWNER_READ OWNER_WRITE OWNER_EXECUTE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
ENDIF(NOT WIN32)

##################################################
#
#     enable other CMake projects to find Vigra
#
##################################################

# config file for CMake FIND_PACKAGE command (for using the build tree)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigBuild.cmake.in

=== src/examples/CMakeLists.txt ===
SET(TARGETS
    convert
    subimage
    invert
    invert_explicitly
    resize
    smooth
    palette
    profile
    pyramid
    edge
    boundarytensor
    watershed
    weightedWatersheds
    voronoi
    nnlsq
    total_variation)

ADD_CUSTOM_TARGET(examples)

FOREACH(TARGET ${TARGETS})
    ADD_EXECUTABLE(example_${TARGET} EXCLUDE_FROM_ALL ${TARGET}.cxx)
    ADD_DEPENDENCIES(examples example_${TARGET})
    TARGET_LINK_LIBRARIES(example_${TARGET} vigraimpex)
ENDFOREACH(TARGET)

ADD_SUBDIRECTORY(tutorial)

=== test/blockwisealgorithms/CMakeLists.txt ===
VIGRA_CONFIGURE_THREADING()

if(THREADING_FOUND)
    # VIGRA_ADD_TEST(test_blockwiselabeling test_labeling.cxx LIBRARIES ${THREADING_LIBRARIES}) # FIXME
    VIGRA_ADD_TEST(test_blockwisewatersheds test_watersheds.cxx LIBRARIES ${THREADING_LIBRARIES})
    VIGRA_ADD_TEST(test_blockwiseconvolution test_convolution.cxx LIBRARIES ${THREADING_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: No threading implementation found.")
    MESSAGE(STATUS "**          test_blockwiselabeling will not be executed on this platform.")
    MESSAGE(STATUS "**          test_blockwisewatersheds will not be executed on this platform.")
    MESSAGE(STATUS "**          test_blockwiseconvolution will not be executed on this platform.")
endif()

=== test/unsupervised/CMakeLists.txt ===
VIGRA_ADD_TEST(test_unsupervised test.cxx)

# the data from 'example_data.h5' are now in 'test_data.hxx', so HDF5 is
# no longer needed for this test
# if(HDF5_FOUND)
    # INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${HDF5_INCLUDE_DIR})

    # ADD_DEFINITIONS(${HDF5_CPPFLAGS})

    # VIGRA_ADD_TEST(test_unsupervised test.cxx LIBRARIES vigraimpex ${HDF5_LIBRARIES})

    # VIGRA_COPY_TEST_DATA(example_data.h5)
# else()
    # MESSAGE(STATUS "** WARNING: test_unsupervised will not be executed")
# endif()

=== test/voxelneighborhood/CMakeLists.txt ===
VIGRA_ADD_TEST(test_voxelneighborhood test.cxx LIBRARIES vigraimpex)

=== debian/changelog ===
libvigraimpex (1.11.2+dfsg-3build5) noble; urgency=medium

  * No-change rebuild against libimath-3-1-29t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 08 Apr 2024 06:00:03 +0000

libvigraimpex (1.11.2+dfsg-3build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:19:40 +0000

libvigraimpex (1.11.2+dfsg-3build3) noble; urgency=medium

  * No-change rebuild against libimath-3-1-29t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 16:10:28 +0000

libvigraimpex (1.11.2+dfsg-3build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:17:21 +0000

libvigraimpex (1.11.2+dfsg-3build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 20:10:21 +0000

libvigraimpex (1.11.2+dfsg-3) unstable; urgency=medium

  * Upload to unstable.
  * Add Bug-Database field to debian/upstream/metadata.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 02 Dec 2023 06:58:39 +0100

libvigraimpex (1.11.2+dfsg-2) experimental; urgency=medium

  * 60_01-Enforce-using-C-11.patch from upstream GIT master: Fix FTBFS on
    i386.

 -- Andreas Metzler <ametzler@debian.org>  Fri, 01 Dec 2023 09:22:12 +0100

libvigraimpex (1.11.2+dfsg-1) experimental; urgency=low

  * Set extend-diff-ignore="^doc/" to fix building twice from the same
    source. Closes: #1046259
  * New upstream version:
    + Unfuzz patches
    + Drop unused testsuite optimization overrides.
    + Tighten cmake build-dep.
  * Let libvigraimpex-dev depend on libtiff-dev instead of libtiff5-dev.
  * [debian/rules] Update code for avoiding linking python-vigra against
    libpython.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 01 Oct 2023 14:53:19 +0200

=== debian/control ===
Source: libvigraimpex
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andreas Metzler <ametzler@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 cmake (>= 3.12),
 debhelper-compat (= 13),
 dh-sequence-numpy3,
 dh-sequence-python3,
 libboost-python-dev,
 libboost-thread-dev,
 libfftw3-dev,
 libhdf5-dev,
 libjpeg-dev,
 libopenexr-dev,
 libpng-dev,
 libtiff-dev,
 python3-dev,
 python3-nose,
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 doxygen,
 ghostscript,
 python3,
 python3-sphinx,
 texlive-latex-base,
 texlive-latex-extra,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/libvigraimpex
Vcs-Git: https://salsa.debian.org/science-team/libvigraimpex.git
Homepage: https://ukoethe.github.io/vigra/

Package: libvigraimpex-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfftw3-dev,
 libhdf5-dev,
 libjpeg-dev,
 libpng-dev,
 libtiff-dev,
 libvigraimpex11 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 libvigraimpex-doc,
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex11
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.

Package: libvigraimpex-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 libvigraimpex-dev,
 python-vigra-doc,
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for the VIGRA library.

Package: python3-vigra
Architecture: any
Section: python
Depends:
 libvigraimpex11 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 python3-pyqt4,
Suggests:
 python-vigra-doc,
 python3-h5py,
Description: Python3 bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package exports the functionality of the VIGRA library to Python3.

Package: python-vigra-doc
Architecture: all
Section: doc
Built-Using:
 ${sphinxdoc:Built-Using},
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 libvigraimpex-doc,
 python3-vigra,
Description: Documentation for Python3 bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for Python3 bindings for the VIGRA library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS   = hardening=+bindnow

export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed
DEB_CFLAGS_MAINT_APPEND   = -Wall -pipe
DEB_CXXFLAGS_MAINT_APPEND = -Wall -pipe
PYTHONVERSIONNUMBER = $(subst python,,$(shell py3versions -d))

AMCONFBUILDINDEP := $(shell if dh_listpackages | grep -q libvigraimpex-doc ; \
	then echo withindep ; \
	else echo archonly ; fi )
MAINBDIR = obj.$(DEB_TARGET_MULTIARCH)
MAINBDIRO = -O--builddirectory=$(MAINBDIR)

# support for Ubuntu development
# # Add -O2 at end to verride -O3 default setting
ifeq ($(DEB_HOST_ARCH),ppc64el)
	DEB_CFLAGS_MAINT_APPEND += -O2
	DEB_CXXFLAGS_MAINT_APPEND += -O2
endif

# fixing floating-point rounding errors on i386 CPUs, see #820429
ifneq (,$(filter $(DEB_HOST_ARCH_CPU), i386))
  DEB_CFLAGS_MAINT_APPEND += -ffloat-store
  DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
endif

# build with Boost.Thread on armel, see #814606
ifeq ($(DEB_HOST_ARCH),armel)
  CMAKE_EXTRAS := -DWITH_BOOST_THREAD=1
  # not set by VigraDetectThreading.cmake
  DEB_CXXFLAGS_MAINT_APPEND += -std=c++11
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mips mipsel))
  DEB_CXXFLAGS_MAINT_APPEND += --param ggc-min-expand=20
endif

export DEB_CFLAGS_MAINT_APPEND
export DEB_CXXFLAGS_MAINT_APPEND

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  export CMAKE_INCLUDE_PATH=/usr/include/hdf5/serial
  export CMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

override_dh_auto_configure:
	dh_auto_configure --verbose $(MAINBDIRO) -- \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)/" \
		-DWITH_OPENEXR=ON \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
		-DPYTHON_INCLUDE_DIR=/usr/include/python$(PYTHONVERSIONNUMBER) \
		$(CMAKE_EXTRAS)
	find $(MAINBDIR)/vigranumpy/ -name 'link.txt' -exec sed -i \
		-e 's/ -lpython[0-9.]\+ / /g' \
		-e 's: /usr/[^ ]*/libpython[0-9.]\+\.so::' \
		-e '/-Wl,-soname,vigranumpycore/b' \
		-e 's/ -Wl,-soname,[^ ]\+ / /' {} +

override_dh_auto_build:
	@echo DEBUGMEMSIZE ; if which free ; then free ; fi
	dh_auto_build --verbose $(MAINBDIRO)
ifeq ($(filter archonly,$(AMCONFBUILDINDEP)),)
	$(MAKE) doc_cpp -C $(MAINBDIR)/
	ln -sf $(CURDIR)/vigranumpy/docsrc/c_api_replaces.txt \
		$(MAINBDIR)/vigranumpy/docsrc/
	$(MAKE) doc_python -C $(MAINBDIR)
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	sed -i 's/exit\ 1/exit\ 0/' \
		$(MAINBDIR)/test/multiarray/run_test_multiarray_chunked.sh #812852
	sed -i 's/-O2/-O2 -O0/' \
		$(MAINBDIR)/test/math/CMakeFiles/test_math.dir/flags.make #817840
#	sed -i 's/-O2/-O2 -O1/' \
		$(MAINBDIR)/test/blockwisealgorithms/CMakeFiles/test_blockwiselabeling.dir/flags.make # https://github.com/ukoethe/vigra/issues/409
#	sed -i 's/-O2/-O2 -O1/' \
		$(MAINBDIR)/test/blockwisealgorithms/CMakeFiles/test_blockwisewatersheds.dir/flags.make # https://github.com/ukoethe/vigra/issues/409, #853513
	sed -i 's/-O2/-O2 -O1/' \
		$(MAINBDIR)/test/gridgraph/CMakeFiles/test_gridgraph.dir/flags.make #871556
	sed -i 's/-O2/-O2 -O0/' \
		$(MAINBDIR)/test/multiarray/CMakeFiles/test_multiarray.dir/flags.make #872037
	$(MAKE) -C $(MAINBDIR) check
	$(MAKE) -C $(MAINBDIR) vigranumpytest
else
	@echo 'Not running testsuite, "nocheck" in $$DEB_BUILD_OPTIONS'
endif

override_dh_auto_install:
	dh_auto_install $(MAINBDIRO)

override_dh_install:
	find debian/tmp -type d -name doctrees -exec rm -rf {} +
	rm -vf debian/tmp/usr/doc/vigra/LICENSE.txt
	dh_install $(MAINBDIRO)
ifeq ($(filter archonly,$(AMCONFBUILDINDEP)),)
	cd debian/libvigraimpex-doc/usr/share/doc/libvigraimpex-dev/ && \
		rm -f html/jquery.js && \
		sed -r -i -e \
		's!(<a href=")LICENSE.txt(">)!\1/usr/share/doc/libvigraimpex-doc/copyright\2!g' \
		html/index.html
endif

%:
	dh $@ --builddirectory=$(MAINBDIR)

## libvigraimpex 1.12.1%2Bdfsg

=== debian/control ===
Source: libvigraimpex
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andreas Metzler <ametzler@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 cmake (>= 3.12),
 debhelper-compat (= 13),
 libfftw3-dev,
 libhdf5-dev,
 libjpeg-dev,
 libopenexr-dev,
 libpng-dev,
 libtiff-dev,
Build-Depends-Indep:
 doxygen,
 ghostscript,
 texlive-latex-base,
 texlive-latex-extra,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/libvigraimpex
Vcs-Git: https://salsa.debian.org/science-team/libvigraimpex.git
Homepage: https://ukoethe.github.io/vigra/

Package: libvigraimpex-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfftw3-dev,
 libhdf5-dev,
 libjpeg-dev,
 libpng-dev,
 libtiff-dev,
 libvigraimpex11 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 libvigraimpex-doc,
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex11
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.

Package: libvigraimpex-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 libvigraimpex-dev,
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for the VIGRA library.

## libvigraimpex 1.12.1+dfsg

=== test/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/include)

INCLUDE(VigraAddTest)

ADD_SUBDIRECTORY(adjacency_list_graph)
ADD_SUBDIRECTORY(binary_forest)
ADD_SUBDIRECTORY(blockwisealgorithms)
ADD_SUBDIRECTORY(classifier)
ADD_SUBDIRECTORY(colorspaces)
ADD_SUBDIRECTORY(convolution)
ADD_SUBDIRECTORY(coordinateiterator)
ADD_SUBDIRECTORY(correlation)
ADD_SUBDIRECTORY(counting_iterator)
ADD_SUBDIRECTORY(delegates)
ADD_SUBDIRECTORY(error)
ADD_SUBDIRECTORY(features)
ADD_SUBDIRECTORY(filter_iterator)
ADD_SUBDIRECTORY(filters)
ADD_SUBDIRECTORY(fourier)
ADD_SUBDIRECTORY(functorexpression)
ADD_SUBDIRECTORY(graph_algorithm)
ADD_SUBDIRECTORY(gridgraph)
ADD_SUBDIRECTORY(hdf5impex)
ADD_SUBDIRECTORY(image)
ADD_SUBDIRECTORY(imgproc)
ADD_SUBDIRECTORY(impex)
ADD_SUBDIRECTORY(integral_image)
ADD_SUBDIRECTORY(math)
ADD_SUBDIRECTORY(merge_graph_adaptor)
ADD_SUBDIRECTORY(morphology)
ADD_SUBDIRECTORY(multiarray)
ADD_SUBDIRECTORY(multiconvolution)
ADD_SUBDIRECTORY(multidistance)
ADD_SUBDIRECTORY(multimorphology)
ADD_SUBDIRECTORY(objectfeatures)
ADD_SUBDIRECTORY(optimization)
ADD_SUBDIREcTORY(permutation)
ADD_SUBDIRECTORY(pixeltypes)
ADD_SUBDIRECTORY(polygon)
ADD_SUBDIRECTORY(polytope)
ADD_SUBDIRECTORY(random_forest_3)
ADD_SUBDIRECTORY(registration)
ADD_SUBDIRECTORY(sampler)
ADD_SUBDIRECTORY(seededRegionGrowing3d)
ADD_SUBDIRECTORY(sifImport)
ADD_SUBDIRECTORY(simpleanalysis)
ADD_SUBDIRECTORY(slic2d)
ADD_SUBDIRECTORY(tensorimaging)
ADD_SUBDIRECTORY(threadpool)
ADD_SUBDIRECTORY(unsupervised)
ADD_SUBDIRECTORY(utilities)
ADD_SUBDIRECTORY(volumelabeling)
ADD_SUBDIRECTORY(voxelneighborhood)
ADD_SUBDIRECTORY(watersheds3d)

=== src/impex/CMakeLists.txt ===
IF(ZLIB_FOUND)
  ADD_DEFINITIONS(-DHasZLIB)
  INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${ZLIB_INCLUDE_DIR})
ENDIF(ZLIB_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
  INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${PNG_INCLUDE_DIR})
ENDIF(PNG_FOUND)

IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
  INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${JPEG_INCLUDE_DIR})
ENDIF(JPEG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(OpenEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR ${OPENEXR_CPPFLAGS})
  INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${OPENEXR_INCLUDE_DIR})
ENDIF(OpenEXR_FOUND)

IF(HDF5_FOUND)
  ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
  INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${HDF5_INCLUDE_DIR})
ENDIF(HDF5_FOUND)

IF (MSVC OR MINGW)
    IF(NOT VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-DVIGRA_DLL)
    ENDIF()
ELSEIF(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)
    IF(VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-fPIC -DPIC)
    ENDIF()
ENDIF ()




ADD_LIBRARY(vigraimpex ${LIBTYPE}
    bmp.cxx
    byteorder.cxx
    codecmanager.cxx
    compression.cxx
    exr.cxx
    gif.cxx
    hdr.cxx
    hdf5impex.cxx
    hdf5_rf_impex.cxx
    iccjpeg.c
    imageinfo.cxx
    jpeg.cxx
    lz4.c
    png.cxx
    pnm.cxx
    rgbe.c
    sifImport.cxx
    sun.cxx
    tiff.cxx
    viff.cxx
    void_vector.cxx)

set(SOVERSION 11)  # increment this after changing the vigraimpex library
IF(MACOSX)
    SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION ${SOVERSION}.${vigra_version}
                          SOVERSION ${SOVERSION} INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}"
                          CXX_STANDARD 11)
ELSE()
    SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION ${SOVERSION}.${vigra_version}
                          SOVERSION ${SOVERSION}
                          CXX_STANDARD 11)
ENDIF()

IF(JPEG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${JPEG_LIBRARIES})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${PNG_LIBRARIES})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${TIFF_LIBRARIES})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  cmake_policy(SET CMP0028 NEW)
  TARGET_LINK_LIBRARIES(vigraimpex ${OPENEXR_LIBRARIES})
ENDIF(OPENEXR_FOUND)

IF(HDF5_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${HDF5_LIBRARIES})
ENDIF(HDF5_FOUND)

IF(ZLIB_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${ZLIB_LIBRARIES})
ENDIF(ZLIB_FOUND)


INSTALL(TARGETS vigraimpex
        EXPORT vigra-targets
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib${LIB_SUFFIX}
        ARCHIVE DESTINATION lib${LIB_SUFFIX})

=== test/adjacency_list_graph/CMakeLists.txt ===
VIGRA_ADD_TEST(test_adjacency_list_graph test.cxx)

=== test/binary_forest/CMakeLists.txt ===
VIGRA_ADD_TEST(test_binary_forest test.cxx)

=== test/convolution/CMakeLists.txt ===
VIGRA_ADD_TEST(test_convolution test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(lenna128.xv lenna_simple_sharpening_orig.xv lenna_gaussian_sharpening_orig.xv lenna128sepgrad.xv lennahessxx.xv lennastxx.xv lenna128recgrad.xv lenna128nonlinear.xv resampling.xv lennahessyy.xv lennastyy.xv lennahessxy.xv lennastxy.xv lenna128rgb.xv lenna128rgbsepgrad.xv lenna_level-2.xv lenna_level-1.xv lenna_level1.xv lenna_level2.xv lenna_levellap0.xv lenna_levellap1.xv lenna_levellap2.xv lennargbst.xv)

=== test/functorexpression/CMakeLists.txt ===
VIGRA_ADD_TEST(test_functorexpression test.cxx)

=== test/hdf5impex/CMakeLists.txt ===
if(HDF5_FOUND)
    INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${HDF5_INCLUDE_DIR})

    ADD_DEFINITIONS(${HDF5_CPPFLAGS})

    VIGRA_ADD_TEST(test_hdf5impex test.cxx LIBRARIES vigraimpex ${HDF5_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: test_hdf5impex will not be executed")
endif()

=== test/polygon/CMakeLists.txt ===
VIGRA_ADD_TEST(test_polygon test.cxx LIBRARIES vigraimpex)

=== test/threadpool/CMakeLists.txt ===
VIGRA_CONFIGURE_THREADING()

if(THREADING_FOUND)
    VIGRA_ADD_TEST(test_threadpool test.cxx LIBRARIES ${THREADING_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: No threading implementation found.")
    MESSAGE(STATUS "**          test_threadpool will not be executed on this platform.")
endif()

=== vigranumpy/lib/CMakeLists.txt ===
FILE(WRITE ${CMAKE_CURRENT_SOURCE_DIR}/__version__.py
     "version = '${vigra_version}'
")
SET(PYSOURCES
    __init__.py
    __version__.py
    tagged_array.py
    arraytypes.py
    ufunc.py
    )

INSTALL(FILES ${PYSOURCES} DESTINATION ${VIGRANUMPY_INSTALL_DIR}/vigra)

SET(TIMESTAMP "${CMAKE_CURRENT_BINARY_DIR}/TIMESTAMP.cxx")
FILE(GLOB TIMESTAMP_FOUND ${TIMESTAMP})
IF(NOT TIMESTAMP_FOUND)
    FILE(WRITE ${TIMESTAMP}
     "// auto-generated dummy file to ensure dependency on Python files. 
// ADD_CUSTOM_TARGET(vigranumpy_lib SOURCES 'dollarsign'{PYSOURCES}) does not seem to be sufficient.
")
ENDIF()

add_custom_command(
    OUTPUT ${TIMESTAMP}
    DEPENDS ${PYSOURCES}
    COMMAND ${CMAKE_COMMAND}
    ARGS -E touch ${TIMESTAMP})

ADD_CUSTOM_TARGET(vigranumpy_lib SOURCES ${TIMESTAMP} ${PYSOURCES})
ADD_DEPENDENCIES(vigranumpy vigranumpy_lib)

FOREACH(lib_file ${PYSOURCES})
    ADD_CUSTOM_COMMAND(
        TARGET vigranumpy_lib
        POST_BUILD
        COMMAND ${CMAKE_COMMAND}
        ARGS -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${lib_file} ${vigranumpy_tmp_dir}/${lib_file}
        COMMENT "Copying Python sources to temporary module directory")
ENDFOREACH(lib_file)
ADD_CUSTOM_COMMAND(
    TARGET vigranumpy_lib
    POST_BUILD
    COMMAND ${CMAKE_COMMAND}
    ARGS -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/pyqt ${vigranumpy_tmp_dir}/pyqt
    COMMENT "Copying Python sources to temporary module directory")

ADD_SUBDIRECTORY(pyqt)

=== vigranumpy/test/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${SUPPRESS_WARNINGS} ${VIGRANUMPY_INCLUDE_DIRS})

SET(TEST_SCRIPTS
    test_arraytypes.py
    test_rf.py
    test_impex.py
    test1.py
    test2.py
    test3.py
    test4.py
    test_color.py
    test_segmentation.py
    test_multidef.py
    )

# setup the file 'testsuccess.cxx' which will become out-of-date when the
# last test failed or when the tests code changed, so that tests are re-executed
SET(TEST_SUCCESS_FILE "${CMAKE_CURRENT_BINARY_DIR}/testsuccess.cxx")

# find the vigranumpy modules that we want to test, and make
# 'testsuccess.cxx' depend on them
# TODO: Does cmake provide a standard way to find those dependencies?
GET_TARGET_PROPERTY(VIGRANUMPY_DEPENDS vigranumpy VIGRA_DEPENDS)
SEPARATE_ARGUMENTS(VIGRANUMPY_DEPENDS)

add_custom_command(
    OUTPUT ${TEST_SUCCESS_FILE}
    DEPENDS ${TEST_SCRIPTS} ${VIGRANUMPY_DEPENDS}
    COMMAND ${CMAKE_COMMAND}
    ARGS -E touch ${TEST_SUCCESS_FILE})

FILE(GLOB TESTSUCCESS_FOUND ${TEST_SUCCESS_FILE})
IF(NOT TESTSUCCESS_FOUND)
    FILE(WRITE ${TEST_SUCCESS_FILE}
     "// auto-generated dummy file to force re-execution of failed tests
")
ENDIF()

# setup the test target
IF(AUTOBUILD_TESTS)
  ADD_LIBRARY(vigranumpytest SHARED
               vigranumpytest.cxx ${TEST_SUCCESS_FILE} ${TEST_SCRIPTS})
ELSE()
  ADD_LIBRARY(vigranumpytest SHARED EXCLUDE_FROM_ALL
               vigranumpytest.cxx ${TEST_SUCCESS_FILE} ${TEST_SCRIPTS})
ENDIF()

execute_process(COMMAND ${Python_EXECUTABLE} -c
                "import sysconfig; print(sysconfig.get_config_var('EXT_SUFFIX'))"
                OUTPUT_VARIABLE EXT_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
SET_TARGET_PROPERTIES(vigranumpytest PROPERTIES PREFIX "" SUFFIX  ${EXT_SUFFIX})

TARGET_LINK_LIBRARIES(vigranumpytest ${VIGRANUMPY_LIBRARIES})
ADD_DEPENDENCIES(check_python vigranumpytest)
ADD_DEPENDENCIES(ctest vigranumpytest)
ADD_DEPENDENCIES(vigranumpytest vigranumpy)

# setup the file 'set_path.py' to ensure that tests are run against the binaries
# which are currently being built, not against (possibly outdated) installed modules
STRING(REGEX REPLACE "/vigra$" "" VIGRANUMPY_TMP_PATH ${vigranumpy_tmp_dir})
FILE(TO_NATIVE_PATH "${VIGRANUMPY_TMP_PATH}" VIGRANUMPY_TMP_PATH)

if(CMAKE_MAJOR_VERSION LESS 3)
    DEPENDENCY_PATH(VIGRAIMPEX_PATH vigraimpex)
    DEPENDENCY_PATH(VIGRANUMPYTEST_PATH vigranumpytest)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/set_paths.py.cmake2.in
                   ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py
                   @ONLY)
else()
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/set_paths.py.in
                   ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py.in
                   @ONLY)

    # two-stage file configuration is necessary because certain target
    # properties are only known at generation time (policy CMP0026)
    if(MSVC)
        file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py
                      INPUT  ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py.in
                      CONDITION $<CONFIG:Release>)
    else()
        file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py
                      INPUT  ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py.in)
    endif()
endif()

IF(NOT PYTHON_PYTEST_NOT_FOUND)
    # copy the individual test scripts
    FOREACH(test_script ${TEST_SCRIPTS})
        ADD_CUSTOM_COMMAND(
            TARGET vigranumpytest
            POST_BUILD
            COMMAND ${CMAKE_COMMAND}
            ARGS -E copy_if_different
            ${CMAKE_CURRENT_SOURCE_DIR}/${test_script} ${CMAKE_CURRENT_BINARY_DIR}/${test_script}
            COMMENT "Running vigranumpy tests")
    ENDFOREACH(test_script)

    VIGRA_NATIVE_PATH(Python_EXECUTABLE ${Python_EXECUTABLE})

    # Windows: Set the DLL path to the binaries currently being built
    #          (so that binaries which are already installed are ignored)
    #          This is not necessary on Linux, because the correct path
    #          is hard-coded into the module by means of 'rpath'
    set(EXTRA_PATH "")
    IF(MSVC)
        SET(PATHSEP ";")
    ELSE()
        SET(PATHSEP ":")
    ENDIF()
    FOREACH(lib ${LIBRARIES})
        if(TARGET ${lib})
            SET(EXTRA_PATH  "$<TARGET_FILE_DIR:${lib}>${PATHSEP}${EXTRA_PATH}")
        endif()
    ENDFOREACH(lib)

    # Setup the test execution script
    # two-stage file configuration is necessary because certain target
    # properties are only known at generation time (policy CMP0026)
    VIGRA_NATIVE_PATH(VIGRA_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
    IF(MSVC OR MINGW)
        get_filename_component(PYTHON_PATH ${Python_EXECUTABLE} PATH)
        get_filename_component(PYTHON_EXE  ${Python_EXECUTABLE} NAME)
        SET(EXTRA_PATH  "${PYTHON_PATH}${PATHSEP}${EXTRA_PATH}")
        SET(VIGRA_TEST_EXECUTABLE "${PYTHON_EXE} -m pytest . %CONFIGURATION%")
        SET(VIGRA_TEST_SCRIPT     "${CMAKE_CURRENT_BINARY_DIR}/run_vigranumpytest.bat")
        CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config/run_test.bat.in
                       ${VIGRA_TEST_SCRIPT}.in
                       @ONLY)
        file(GENERATE OUTPUT "${VIGRA_TEST_SCRIPT}"
                      INPUT  "${VIGRA_TEST_SCRIPT}.in")
    ELSE()
        SET(VIGRA_TEST_EXECUTABLE "${Python_EXECUTABLE} -m pytest .")
        SET(VIGRA_TEST_SCRIPT     "${CMAKE_CURRENT_BINARY_DIR}/run_vigranumpytest.sh")
        CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config/run_test.sh.in
                       ${VIGRA_TEST_SCRIPT}.in
                       @ONLY)
        EXECUTE_PROCESS(COMMAND chmod u+x ${VIGRA_TEST_SCRIPT}.in OUTPUT_QUIET ERROR_QUIET)
        file(GENERATE OUTPUT "${VIGRA_TEST_SCRIPT}"
                      INPUT  "${VIGRA_TEST_SCRIPT}.in")
    ENDIF()

    # register the test execution command
    # VIGRA_CONFIGURATION is 'release' or 'debug' on Windows, nothing on Linux
    # variable CMAKE_CFG_INTDIR contains a dot '.' for a Windows nmake build, or
    #                           '$(OutDir)' for a VisualStudio build (OutDir will be
    #                           set by VS at build time)
    SET(VIGRA_CONFIGURATION ${CMAKE_CFG_INTDIR})

    IF(AUTOEXEC_TESTS)
        add_custom_command(
            TARGET vigranumpytest
            POST_BUILD
            COMMAND ${VIGRA_TEST_SCRIPT} ARGS ${VIGRA_CONFIGURATION}
            COMMENT "Running vigranumpy tests")
    ENDIF()

    ADD_TEST(vigranumpytest ${VIGRA_TEST_SCRIPT} ${VIGRA_CONFIGURATION})

    # if we configure for Visual Studio, setup the debug command
    if(MSVC AND NOT (MSVC_VERSION VERSION_LESS "11"))
        # FIXME: this may not portable between VC versions (works for 11.0 - 14.0)
        set(VIGRA_TEST_EXE "${Python_EXECUTABLE}")
        set(VIGRA_TEST_ARGS "-m pytest . \$(Configuration)")
        configure_file(${CMAKE_SOURCE_DIR}/config/testdebug.vcxproj.user.in
                       ${CMAKE_CURRENT_BINARY_DIR}/vigranumpytest.vcxproj.user
                       @ONLY)
    endif()
ELSE()
        MESSAGE(STATUS "  vigranumpy tests will NOT be executed (pytest missing)")
ENDIF()

=== vigranumpy/lib/pyqt/CMakeLists.txt ===
SET(PYSOURCES
    __init__.py
    imagewindow.py
    quickdialog.py
    overlays.py
    viewer2svg.py
    )

INSTALL(FILES ${PYSOURCES} DESTINATION ${VIGRANUMPY_INSTALL_DIR}/vigra/pyqt)

=== debian/changelog ===
libvigraimpex (1.12.1+dfsg-1) unstable; urgency=medium

  * Team Upload
  * New upstream version 1.12.1+dfsg that replaces Nose with Pytest.
  * Fix watch file
  * Apply Multi-Arch hint

 -- Alexandre Detiste <tchet@debian.org>  Wed, 04 Sep 2024 14:47:25 +0200

=== debian/control ===
--- 
+++ 
@@ -7,15 +7,24 @@
 Build-Depends:
  cmake (>= 3.12),
  debhelper-compat (= 13),
+ dh-sequence-numpy3,
+ dh-sequence-python3,
+ libboost-python-dev,
+ libboost-thread-dev,
  libfftw3-dev,
  libhdf5-dev,
  libjpeg-dev,
  libopenexr-dev,
  libpng-dev,
  libtiff-dev,
+ python3-dev,
+ python3-pytest,
 Build-Depends-Indep:
+ dh-sequence-sphinxdoc,
  doxygen,
  ghostscript,
+ python3,
+ python3-sphinx,
  texlive-latex-base,
  texlive-latex-extra,
 Rules-Requires-Root: no
@@ -77,6 +86,7 @@
  ${misc:Depends},
 Suggests:
  libvigraimpex-dev,
+ python-vigra-doc,
 Description: Documentation for the C++ computer vision library
  Vision with Generic Algorithms (VIGRA) is a computer vision library
  that puts its main emphasis on flexible algorithms, because
@@ -88,3 +98,51 @@
  structures, within your environment.
  .
  This package contains documentation for the VIGRA library.
+
+Package: python3-vigra
+Architecture: any
+Section: python
+Depends:
+ libvigraimpex11 (= ${binary:Version}),
+ ${misc:Depends},
+ ${python3:Depends},
+ ${shlibs:Depends},
+Recommends:
+ python3-pyqt4,
+Suggests:
+ python-vigra-doc,
+ python3-h5py,
+Description: Python3 bindings for the C++ computer vision library
+ Vision with Generic Algorithms (VIGRA) is a computer vision library
+ that puts its main emphasis on flexible algorithms, because
+ algorithms represent the principle know-how of this field. The
+ library was consequently built using generic programming as
+ introduced by Stepanov and Musser and exemplified in the C++ Standard
+ Template Library. By writing a few adapters (image iterators and
+ accessors) you can use VIGRA's algorithms on top of your data
+ structures, within your environment.
+ .
+ This package exports the functionality of the VIGRA library to Python3.
+
+Package: python-vigra-doc
+Architecture: all
+Section: doc
+Built-Using:
+ ${sphinxdoc:Built-Using},
+Depends:
+ ${misc:Depends},
+ ${sphinxdoc:Depends},
+Suggests:
+ libvigraimpex-doc,
+ python3-vigra,
+Description: Documentation for Python3 bindings for the C++ computer vision library
+ Vision with Generic Algorithms (VIGRA) is a computer vision library
+ that puts its main emphasis on flexible algorithms, because
+ algorithms represent the principle know-how of this field. The
+ library was consequently built using generic programming as
+ introduced by Stepanov and Musser and exemplified in the C++ Standard
+ Template Library. By writing a few adapters (image iterators and
+ accessors) you can use VIGRA's algorithms on top of your data
+ structures, within your environment.
+ .
+ This package contains documentation for Python3 bindings for the VIGRA library.

## libvigraimpex 1.12.2%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,9 @@
 if(SUPPRESS_3RD_PARTY_WARNINGS)
     set(SUPPRESS_WARNINGS SYSTEM)
 endif()
+
+set(CMAKE_CXX_STANDARD 11 CACHE STRING "The CXX standard used for the project")
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 IF(VIGRA_STATIC_LIB)
     SET(LIBTYPE STATIC)
@@ -168,7 +171,7 @@
 ENDIF()
 
 IF(WITH_BOOST)
-    VIGRA_FIND_PACKAGE(Boost ${BOOST_MINIMUM_VERSION} COMPONENTS ${WITH_BOOST_COMPONENTS})
+    find_package(Boost CONFIG ${BOOST_MINIMUM_VERSION} COMPONENTS ${WITH_BOOST_COMPONENTS})
     # FIXME: the following may be unstable between cmake versions
     SET(Boost_LIB_SUFFIX "${_boost_COMPILER}${_boost_MULTITHREADED}-${Boost_LIB_VERSION}")
 ENDIF()
@@ -371,5 +374,3 @@
 #
 ##################################################
 
-# config file for CMake FIND_PACKAGE command (for using the build tree)
-CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigBuild.cmake.in

=== test/multidistance/CMakeLists.txt ===
VIGRA_ADD_TEST(test_multidistance test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(
    blatt.xv
    raw_skeleton.xv
    skeleton_length.xv
    skeleton_length_greater_100.xv
    skeleton_length_greater_50_percent.xv
    skeleton_salience.xv
    skeleton_salience_greater_10.xv
    skeleton_salience_greater_60_percent.xv
    skeleton_topology.xv
    skeleton_topology_without_center.xv
)

=== test/polytope/CMakeLists.txt ===
IF(WITH_LEMON)
    VIGRA_ADD_TEST(test_polytope test.cxx LIBRARIES ${LEMON_LIBRARY})
    INCLUDE_DIRECTORIES(${LEMON_INCLUDE_DIR})
    SET_TARGET_PROPERTIES(test_polytope PROPERTIES COMPILE_FLAGS "-DWITH_LEMON")
ENDIF(WITH_LEMON)
